import { CategoryAxisBase } from "./CategoryAxisBase";
import { IZoomableCategoryAxis } from "./IZoomableCategoryAxis";
import { Type, IList$1 } from "igniteui-angular-core";
import { DependencyProperty } from "igniteui-angular-core";
import { Axis } from "./Axis";
import { AxisOrientation } from "./AxisOrientation";
import { AxisView } from "./AxisView";
import { AxisLabelPanelBase } from "./AxisLabelPanelBase";
import { Rect } from "igniteui-angular-core";
import { ScalerParams } from "./ScalerParams";
import { SeriesViewer } from "./SeriesViewer";
import { CategoryMode } from "./CategoryMode";
import { IGetItemAtIndex } from "igniteui-angular-core";
import { CategoryAxisBaseView } from "./CategoryAxisBaseView";
/**
 * @hidden
 */
export declare class CategoryXAxis extends CategoryAxisBase implements IZoomableCategoryAxis {
    static $t: Type;
    bm(): AxisView;
    kb(a: AxisView): void;
    p8: CategoryXAxisView;
    ak(): Axis;
    jr(a: Axis): void;
    ju(a: Axis, b: string): void;
    constructor();
    private qn;
    get qp(): number;
    set qp(a: number);
    private qm;
    get qo(): number;
    set qo(a: number);
    az(): AxisLabelPanelBase;
    getCategorySize(a: Rect, b: Rect, c: Rect): number;
    ou(a: Rect, b: Rect, c: Rect): number;
    getGroupCenter(a: number, b: Rect, c: Rect, d: Rect): number;
    fe(): number;
    q2(a: any): void;
    ft(a: number, b: ScalerParams): number;
    protected p7(a: IList$1<number[]>): number[][];
    j5(a: IList$1<number[]>, b: IList$1<number>, c: number, d: number, e: ScalerParams): void;
    fu(a: number, b: ScalerParams, c: CategoryMode): number;
    private qj;
    fw(a: number, b: ScalerParams): number;
    fx(a: number, b: ScalerParams, c: CategoryMode): number;
    getUnscaledValue3(a: number, b: Rect, c: Rect, d: CategoryMode): number;
    q3(a: number, b: number): void;
    qq: any;
    protected k4(a: boolean): void;
    d4(): boolean;
    getWindowZoomFromCategories(a: number): number;
    getWindowZoomFromItemSpan(a: number): number;
    q5(): void;
    q4(): void;
    protected kf(a: any, b: string, c: any, d: any): void;
    j1(a: string): void;
    qf: number;
    qg: number;
    zoomMaximumCategoryRange: number;
    zoomMaximumItemSpan: number;
    zoomToCategoryRange: number;
    zoomToCategoryStart: number;
    zoomToItemSpan: number;
    static readonly q8: DependencyProperty;
    get qk(): number;
    set qk(a: number);
    qa(): boolean;
    private qb;
    get qd(): number;
    set qd(a: number);
    f5(): number;
    static readonly q9: DependencyProperty;
    get ql(): number;
    set ql(a: number);
    private qc;
    get qe(): number;
    set qe(a: number);
    ok(a: SeriesViewer): boolean;
    protected get_bk(): AxisOrientation;
    get bk(): AxisOrientation;
    protected p9(): IGetItemAtIndex;
    protected qi(a: number, b: ScalerParams): number;
    protected qh(a: number, b: number, c: boolean, d: ScalerParams): number;
    get isVertical(): boolean;
    j$d(a: number, b: ScalerParams): number;
    j$c(a: number, b: ScalerParams): number;
    j$e(a: IList$1<number[]>, b: IList$1<number>, c: number, d: number, e: ScalerParams): void;
    j$f(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    j$g(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    get j$b(): boolean;
    j$a(): number[];
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class CategoryXAxisView extends CategoryAxisBaseView {
    static $t: Type;
    protected bm: CategoryXAxis;
    constructor(a: CategoryXAxis);
    al(): void;
}
